Bug 124836 - AX: Add accessibility tests for MathML operators
Summary: AX: Add accessibility tests for MathML operators
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: Accessibility (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P2 Normal
Assignee: Frédéric Wang (:fredw)
URL:
Keywords: InRadar
Depends on: 99620 139582
Blocks: 159208
  Show dependency treegraph
 
Reported: 2013-11-25 04:22 PST by Frédéric Wang (:fredw)
Modified: 2016-06-28 21:32 PDT (History)
10 users (show)

See Also:


Attachments
Patch (3.93 KB, patch)
2016-06-28 03:08 PDT, Frédéric Wang (:fredw)
buildbot: commit-queue-
Details | Formatted Diff | Diff
Archive of layout-test-results from ews126 for ios-simulator-wk2 (1.44 MB, application/zip)
2016-06-28 04:09 PDT, Build Bot
no flags Details
Patch to get test expectations (3.45 KB, patch)
2016-06-28 04:58 PDT, Frédéric Wang (:fredw)
no flags Details | Formatted Diff | Diff
Patch (6.13 KB, patch)
2016-06-28 10:06 PDT, Frédéric Wang (:fredw)
jdiggs: review+
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Frédéric Wang (:fredw) 2013-11-25 04:22:53 PST
This is for when bug 99620 is fixed.

I'm not sure I see tests for

AccessibilityRenderObject::isMathOperator()                 (<mo> renderers or the anonymous created by <mfenced>)
AccessibilityRenderObject::isMathFenceOperator()            (fences created by <mfenced>)
AccessibilityRenderObject::isMathSeparatorOperator()        (separators created by <mfenced>)

After bugs 99620 is fixed, we will have the following attributes:

<mo fence="true"> => isMathFenceOperator
<mo separator="true"> => isMathSeparatorOperator
<mo separator="true" fence="true"> => isMathFenceOperator && isMathSeparatorOperator (not sure this really exists in real math)

Also, the values can be determined from the operator dictionary (http://www.w3.org/TR/MathML3/appendixc.html). For example the two markup should be equivalent for the AT:

<math><mo>(</mo><mi>x</mi><mo>,<mo><mi>y</mi><mo>;</mo><mo>]</mo></math>

and with explicit attributes

<math><mo fence="true">(</mo><mi>x</mi><mo separator="true">,<mo><mi>y</mi><mo separator="true">;</mo><mo fence="true">]</mo></math>

Similarly, we should have the equivalence between mfenced and its expanded form. See http://www.w3.org/TR/MathML3/chapter3.html#presm.mfenced
Comment 1 Frédéric Wang (:fredw) 2013-11-25 04:24:59 PST
There is also the separate questions of whether we want to expose other operator properties to the AT. Most of the new properties are purely visual but perhaps "LargeOp" and "Accent" have a semantic meaning that is worth exposing.
Comment 2 Radar WebKit Bug Importer 2014-02-20 00:24:02 PST
<rdar://problem/16119302>
Comment 3 Frédéric Wang (:fredw) 2014-02-20 00:29:55 PST
@Chris: now that bug 99620 is fixed, I let you ensure correct test coverage for the AT and decide whether it is worth exposing things like "LargeOp" or "Accent".
Comment 4 Frédéric Wang (:fredw) 2014-03-12 07:33:57 PDT
For the record: the accessibility test has been disabled in http://trac.webkit.org/changeset/165436 because the change broke the <mfenced> test. We need to be restore it and ensure it works with normal <mo> elements too.
Comment 5 Frédéric Wang (:fredw) 2016-06-28 03:08:59 PDT
Created attachment 282234 [details]
Patch
Comment 6 Build Bot 2016-06-28 04:09:25 PDT
Comment on attachment 282234 [details]
Patch

Attachment 282234 [details] did not pass ios-sim-ews (ios-simulator-wk2):
Output: http://webkit-queues.webkit.org/results/1585623

New failing tests:
animations/multiple-backgrounds.html
Comment 7 Build Bot 2016-06-28 04:09:29 PDT
Created attachment 282240 [details]
Archive of layout-test-results from ews126 for ios-simulator-wk2

The attached test failures were seen while running run-webkit-tests on the ios-sim-ews.
Bot: ews126  Port: ios-simulator-wk2  Platform: Mac OS X 10.11.4
Comment 8 Frédéric Wang (:fredw) 2016-06-28 04:58:13 PDT
Created attachment 282243 [details]
Patch to get test expectations
Comment 9 Frédéric Wang (:fredw) 2016-06-28 10:06:14 PDT
Created attachment 282252 [details]
Patch

Adding the mac expectation...
Comment 10 Joanmarie Diggs (irc: joanie) 2016-06-28 14:43:25 PDT
Comment on attachment 282252 [details]
Patch

Yay for more tests! :) Thanks!
Comment 11 Frédéric Wang (:fredw) 2016-06-28 21:32:08 PDT
Committed r202610: <http://trac.webkit.org/changeset/202610>